﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Syncfusion.SfAutoComplete.XForms;
using Xamarin.Forms;

namespace AutoCompleteWithListView
{
    // Learn more about making custom code visible in the Xamarin.Forms previewer
    // by visiting https://aka.ms/xamarinforms-previewer
    [DesignTimeVisible(false)]
    public partial class MainPage : ContentPage
    {
        public MainPage()
        {
            InitializeComponent();
            this.BindingContext = new BookInfoRepository();      
        }

        private void AutoComplete_SelectionChanged(object sender, Syncfusion.SfAutoComplete.XForms.SelectionChangedEventArgs e)
        {
            var bc = (BookInfoRepository)BindingContext;
            var item = e.Value.ToString();
            if (bc.Big50ObservableCollection.Contains(item))
            {
                bc.Big50ObservableCollection.Remove(item);
            }
            bc.Big50ObservableCollection.Insert(0, item);
        }
    }

    public class CustomAutoComplete : SfAutoComplete
    {
        //ObservableCollection<string> list;
        public CustomAutoComplete()
        {
            //list = new ObservableCollection<string>();
            //for (int i = 0; i < 50000; i++)
            //{
            //    list.Add(i.ToString());
            //}
            //this.DataSource = list;
            //this.SelectionChanged += CustomAutoComplete_SelectionChanged;
        }

        //private void CustomAutoComplete_SelectionChanged(object sender, Syncfusion.SfAutoComplete.XForms.SelectionChangedEventArgs e)
        //{
            //int i;
            //list = new ObservableCollection<string>();
            //for ( i = 0; i < 50000; i++)
            //{
            //    if (i == 0)
            //    {
            //        list.Add(e.Value.ToString());
            //    }
            //    else
            //    {
            //        list.Add(i.ToString());
            //    }
            //}
            //this.DataSource = list;
        //}
    }
    public class BookInfo : INotifyPropertyChanged
    {

        private string bookName;
        private string bookDesc;

        public string BookName
        {
            get { return bookName; }
            set
            {
                bookName = value;
                OnPropertyChanged("BookName");
            }
        }

        public string BookDescription
        {
            get { return bookDesc; }
            set
            {
                bookDesc = value;
                OnPropertyChanged("BookDescription");
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        public void OnPropertyChanged(string name)
        {
            if (this.PropertyChanged != null)
                this.PropertyChanged(this, new PropertyChangedEventArgs(name));
        }
    }


    public class BookInfoRepository
    {
        private ObservableCollection<BookInfo> bookInfo;

        public ObservableCollection<BookInfo> BookInfo
        {
            get { return bookInfo; }
            set { this.bookInfo = value; }
        }

        private ObservableCollection<string> _big50kObservableCollection;

        public ObservableCollection<string> Big50ObservableCollection
        {
            get => _big50kObservableCollection;
            set => _big50kObservableCollection = value;
        }

        public BookInfoRepository()
        {
            GenerateBookInfo();
            GenerateBig50ObservableCollection();
        }

        internal void GenerateBookInfo()
        {
            bookInfo = new ObservableCollection<BookInfo>();
            for (int i = 0; i < 100; i++)
            {
                bookInfo.Add(new BookInfo() { BookName = i++.ToString(), BookDescription = "Object-oriented programming is a programming paradigm based on the concept of objects" });
            }
        }

        internal void GenerateBig50ObservableCollection()
        {
            _big50kObservableCollection = new ObservableCollection<string>();
            for (int i = 0; i < 50000; i++)
            {
                _big50kObservableCollection.Add($"{i}");
            }
        }
    }
}
